VERSION 5.00
Begin VB.Form fmVBFTPJR 
   Caption         =   "phinds FTP sample"
   ClientHeight    =   5880
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8400
   LinkTopic       =   "Form1"
   ScaleHeight     =   5880
   ScaleWidth      =   8400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPutFile 
      Caption         =   "PUT A FILE"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   4320
      TabIndex        =   4
      Top             =   120
      Width           =   1815
   End
   Begin VB.CommandButton cmdGetFile 
      Caption         =   "GET A FILE"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   2280
      TabIndex        =   3
      Top             =   120
      Width           =   1815
   End
   Begin VB.ListBox lstBox1 
      Height          =   4545
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   8175
   End
   Begin VB.CommandButton cmdGetList 
      Caption         =   "SHOW REMOTE DIRECTORY"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "QUIT"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   6360
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "fmVBFTPJR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' this FTP sample project was created by modifying a more extensive FTP sample
' project.  Both this project and the original are available at:
'
'   http://www.hobbithouseinc.com/VB
'
' This project provides the ability to download the contents of an FTP site
' folder (directory), to download a single file, and to upload a single file.
' The FTP site info present in the Walnut Creek cd-rom site's mirror of
' Project Gutenberg.
'
'   N   N  OOO  TTTTT EEEEE         if you do not change the variables in the
'   N   N O   O   T   E             modWinInet module, upload won't work.  I
'   NN  N O   O   T   E             have fully tested it using my own web site
'   N N N O   O   T   EEEE          but you'll need to use another FTP site.  I
'   N  NN O   O   T   E             have put in notes to aid you in that in the
'   N   N O   O   T   E             modWinInet module
'   N   N  OOO    T   EEEEE
'
Dim bActiveSession As Boolean
Dim hOpen As Long, hConnection As Long

Dim EnumItemNameBag As New Collection
Dim EnumItemSizeBag As New Collection
Dim EnumItemAttributeBag As New Collection
'
'
'
Private Sub cmdGetFile_Click()
    Dim bRet As Boolean
    '
    ' open an internet connection
    '
    hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_DIRECT, _
            vbNullString, vbNullString, 0)
    If hOpen = 0 Then ErrorOut Err.LastDllError, "InternetOpen"
    '
    ' open an FTP session
    '
    If Not bActiveSession And hOpen <> 0 Then
        hConnection = InternetConnect(hOpen, kSERVERNAME, _
                INTERNET_INVALID_PORT_NUMBER, kUSERNAME, kPASSWORD, _
                INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE, 0)
        If hConnection = 0 Then
            bActiveSession = False
            ErrorOut Err.LastDllError, "InternetConnect"
        Else
            rcd ServerBasePath1
            bRet = FtpGetFile(hConnection, szFileRemote, _
                    App.Path & "\downloaded.gif", False, _
                    INTERNET_FLAG_RELOAD, FTP_TRANSFER_TYPE_BINARY, 0)
            If bRet = False Then
                ErrorOut Err.LastDllError, "FtpGetFile"
            Else
                lstBox1.AddItem " "
                lstBox1.AddItem "file " & szFileRemote _
                        & " was downloaded successfully"
                lstBox1.AddItem " "
            End If
        End If
    Else
        MsgBox "session failed"
    End If
    '
    ' kill the connection
    '
    If hConnection <> 0 Then InternetCloseHandle hConnection
    If hOpen Then InternetCloseHandle hOpen
End Sub
'
'
'
Private Sub cmdPutFile_Click()
    Dim bRet As Boolean
    '
    ' open an internet connection
    '
    hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_DIRECT, _
            vbNullString, vbNullString, 0)
    If hOpen = 0 Then ErrorOut Err.LastDllError, "InternetOpen"
    '
    ' open an FTP session
    '
    If Not bActiveSession And hOpen <> 0 Then
        hConnection = InternetConnect(hOpen, kSERVERNAME, _
                INTERNET_INVALID_PORT_NUMBER, kUSERNAME, kPASSWORD, _
                INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE, 0)
        If hConnection = 0 Then
            bActiveSession = False
            ErrorOut Err.LastDllError, "InternetConnect"
        Else
            rcd ServerBasePath1
            bRet = FtpPutFile(hConnection, App.Path & "\txtfiletoupload.txt", _
                    "uploaded.txt", FTP_TRANSFER_TYPE_ASCII, 0)
            If bRet = False Then
                ErrorOut Err.LastDllError, "FtpPutFile"
                Exit Sub
            Else
                lstBox1.AddItem "file upload was successful"
            End If
        End If
    Else
        MsgBox "session failed"
    End If
    '
    ' kill the connection
    '
    If hConnection <> 0 Then InternetCloseHandle hConnection
    If hOpen Then InternetCloseHandle hOpen
End Sub
'
' cmdGetList --- get the contents of a directory on the FTP server
'
Private Sub cmdGetList_Click()
    Dim ix As Integer
    '
    ' open an internet connection
    '
    hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_DIRECT, _
            vbNullString, vbNullString, 0)
    If hOpen = 0 Then ErrorOut Err.LastDllError, "InternetOpen"
    '
    ' open an FTP session
    '
    If Not bActiveSession And hOpen <> 0 Then
        hConnection = InternetConnect(hOpen, kSERVERNAME, _
                INTERNET_INVALID_PORT_NUMBER, _
        kUSERNAME, kPASSWORD, INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE, 0)
        If hConnection = 0 Then
            bActiveSession = False
            ErrorOut Err.LastDllError, "InternetConnect"
        Else
            FtpEnumDirectory (ServerBasePath2)
            If EnumItemNameBag.Count = 0 Then Exit Sub
            '
            ' show the directory contents in a list box
            '
            lstBox1.AddItem "here's a list of what was found: "
            lstBox1.AddItem " "
            For ix = 1 To EnumItemNameBag.Count
                If EnumItemAttributeBag.Item(ix) = 16 Then
                    lstBox1.AddItem "folder: " & EnumItemNameBag.Item(ix)
                Else
                    lstBox1.AddItem "file:   " & EnumItemNameBag.Item(ix) _
                        & " with " & CStr(EnumItemSizeBag.Item(ix)) & " bytes"
                End If
            Next ix
        End If
    End If
    If hConnection <> 0 Then InternetCloseHandle hConnection
    If hOpen Then InternetCloseHandle hOpen
End Sub
'
' on load, center the form and init variables as needed
'
Private Sub Form_Load()
    Dim scrWide As Long
    Dim scrHigh As Long
    Dim imgI As ListImage
    '
    ' capture screen dimensions
    '
    scrWide = Screen.Width
    scrHigh = Screen.Height
    '
    ' size and center this form
    '
    Me.Left = (scrWide - Me.Width) / 2
    Me.Top = (scrHigh - Me.Height) / 2
    '
    '
    '
    bActiveSession = False
    hOpen = 0
    hConnection = 0
End Sub
'
' on unload, close the connection
'
Private Sub Form_Unload(Cancel As Integer)
    cmdEnd_Click
End Sub
'
'
'
Private Sub cmdEnd_Click()
    If hConnection <> 0 Then InternetCloseHandle hConnection
    Unload Me
    End
End Sub
'
' ClearBags --- clear the collections
'
Private Sub ClearBags()
    Dim Num As Integer
    For Num = 1 To EnumItemNameBag.Count
        EnumItemNameBag.Remove 1
    Next Num
    For Num = 1 To EnumItemAttributeBag.Count
        EnumItemAttributeBag.Remove 1
    Next Num
    For Num = 1 To EnumItemSizeBag.Count
        EnumItemSizeBag.Remove 1
    Next Num
End Sub
'
' rcd --- remote change directory; asks the FTP host to do a CD to the
'         full-path-specified directory
'
Private Sub rcd(pszDir As String)
    If pszDir = "" Then
        MsgBox "Please enter the directory to change to"
        Exit Sub
    Else
        Dim sPathFromRoot As String
        Dim bRet As Boolean
        If InStr(1, pszDir, kSERVERNAME) Then
            sPathFromRoot = Mid(pszDir, Len(kSERVERNAME) + 1, _
                            Len(pszDir) - Len(kSERVERNAME))
        Else
            sPathFromRoot = pszDir
        End If
        If sPathFromRoot = "" Then
            sPathFromRoot = "/"
        End If
        bRet = FtpSetCurrentDirectory(hConnection, sPathFromRoot)
        If bRet = False Then
            ErrorOut Err.LastDllError, "rcd"
        End If
    End If
End Sub
'
' ErrorOut --- show error & ask whether or not to close
'
Function ErrorOut(dError As Long, szCallFunction As String)
    Dim dwIntError As Long, dwLength As Long
    Dim strBuffer As String
    If dError = ERROR_INTERNET_EXTENDED_ERROR Then
        InternetGetLastResponseInfo dwIntError, vbNullString, dwLength
        strBuffer = String(dwLength + 1, 0)
        InternetGetLastResponseInfo dwIntError, strBuffer, dwLength
        MsgBox szCallFunction & " Extd Err: " & dwIntError & " " & strBuffer
    End If
    If MsgBox(szCallFunction & " Err: " & dError & vbCrLf _
            & "Close Connection and Session?", vbYesNo) = vbYes Then
        If hConnection Then
            InternetCloseHandle hConnection
        End If
        If hOpen Then
            InternetCloseHandle hOpen
        End If
        hConnection = 0
        hOpen = 0
        bActiveSession = False
        ClearBags
    End If
End Function
'
' FtpEnumDirectory --- ask the FTP host for the contents of a full-path-specified
'                      directory and save that information (that is, the names of
'                      all the files and directories and their size, if files) in
'                      the collections for name, size, and attributes.  NOTE: the
'                      attribute is 16 for folders and 128 for files
'
Private Sub FtpEnumDirectory(strDirectory As String)
    
    Dim hFind As Long
    Dim nLastError As Long
    Dim dError As Long
    Dim ptr As Long
    Dim pData As WIN32_FIND_DATA
    Dim bRet As Boolean
    Dim strItemName As String
    '
    ' clear the collections
    '
    ClearBags
    '
    ' if the directory to be enumerated is not the root directory, then
    ' do a remote change directory (rcd) to get to it
    '
    If Len(strDirectory) > 0 Then
        rcd (strDirectory)
    End If
    '
    ' zero out the file name string
    '
    pData.cFileName = String(MAX_PATH, 0)
    '
    ' find the first entry
    '
    hFind = FtpFindFirstFile(hConnection, "*.*", pData, 0, 0)
    nLastError = Err.LastDllError
    '
    ' if no entries were found, then just tell the user.  If there was
    ' an actual error, report it
    '
    If hFind = 0 Then
        If (nLastError = ERROR_NO_MORE_FILES) Then
            MsgBox strDirectory & " is an empty folder"
        Else
            ErrorOut nLastError, "FtpFindFirstFile"
        End If
        Exit Sub
    End If
    '
    ' say there is one entry found (so far) and no error
    '
    dError = NO_ERROR
    '
    ' save the information for the one entry found so far
    '
    EnumItemAttributeBag.Add pData.dwFileAttributes
    strItemName = Left(pData.cFileName, InStr(1, pData.cFileName, String(1, 0), vbBinaryCompare) - 1)
    EnumItemNameBag.Add strItemName
    EnumItemSizeBag.Add pData.nFileSizeLow
    '
    ' get the rest of the entries
    '
    Do
        pData.cFileName = String(MAX_PATH, 0)
        bRet = InternetFindNextFile(hFind, pData)
        '
        ' if nothing found, check for error or just no more entries
        '
        If Not bRet Then
            '
            ' if there are no more entries, then just exit the loop but if
            ' there is an actual error, report it and exit the sub
            '
            dError = Err.LastDllError
            If dError = ERROR_NO_MORE_FILES Then
                Exit Do
            Else
                ErrorOut dError, "InternetFindNextFile"
                InternetCloseHandle (hFind)
               Exit Sub
            End If
        Else
            '
            ' save the information for this entry
            '
            EnumItemAttributeBag.Add pData.dwFileAttributes
            strItemName = Left(pData.cFileName, InStr(1, pData.cFileName, String(1, 0), vbBinaryCompare) - 1)
            EnumItemNameBag.Add strItemName
            EnumItemSizeBag.Add pData.nFileSizeLow
       End If
    Loop
    '
    ' close the file-find connection
    '
    InternetCloseHandle (hFind)
End Sub

